/**
 */
package de.mdelab.mlannotations;

import org.eclipse.emf.common.util.EList;

import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MLElementWithUUID;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>ML Annotation</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An annotation contains additional information attached to an AnnotatedElement. This information is contained in AnnotationDetails.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlannotations.MLAnnotation#getSource <em>Source</em>}</li>
 *   <li>{@link de.mdelab.mlannotations.MLAnnotation#getAnnotationDetails <em>Annotation Details</em>}</li>
 *   <li>{@link de.mdelab.mlannotations.MLAnnotation#getElement <em>Element</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlannotations.MlannotationsPackage#getMLAnnotation()
 * @model
 * @generated
 */
public interface MLAnnotation extends MLElementWithUUID {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc --> A key
	 * that identifies the type of the annotation. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Source</em>' attribute.
	 * @see #setSource(String)
	 * @see de.mdelab.mlannotations.MlannotationsPackage#getMLAnnotation_Source()
	 * @model required="true"
	 * @generated
	 */
	String getSource();

	/**
	 * Sets the value of the '{@link de.mdelab.mlannotations.MLAnnotation#getSource <em>Source</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' attribute.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(String value);

	/**
	 * Returns the value of the '<em><b>Annotation Details</b></em>' reference
	 * list. The list contents are of type
	 * {@link de.mdelab.mlannotations.MLAnnotationDetails}. <!-- begin-user-doc
	 * --> <!-- end-user-doc --> <!-- begin-model-doc --> The AnnotationDetails
	 * contained in this annotation. <!-- end-model-doc -->
	 * 
	 * @return the value of the '<em>Annotation Details</em>' reference list.
	 * @see de.mdelab.mlannotations.MlannotationsPackage#getMLAnnotation_AnnotationDetails()
	 * @model ordered="false"
	 * @generated
	 */
	EList<MLAnnotationDetails> getAnnotationDetails();

	/**
	 * Returns the value of the '<em><b>Element</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlcore.MLAnnotatedElement#getAnnotations <em>Annotations</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The element annotated by this annotation.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Element</em>' container reference.
	 * @see #setElement(MLAnnotatedElement)
	 * @see de.mdelab.mlannotations.MlannotationsPackage#getMLAnnotation_Element()
	 * @see de.mdelab.mlcore.MLAnnotatedElement#getAnnotations
	 * @model opposite="annotations" required="true" transient="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlcore/mlannotations/1.0!MLAnnotation!element'"
	 * @generated
	 */
	MLAnnotatedElement getElement();

	/**
	 * Sets the value of the '{@link de.mdelab.mlannotations.MLAnnotation#getElement <em>Element</em>}' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Element</em>' container reference.
	 * @see #getElement()
	 * @generated
	 */
	void setElement(MLAnnotatedElement value);

} // MLAnnotation
