/**
 */
package de.mdelab.mlannotations;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import de.mdelab.mlcore.MlcorePackage;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.mdelab.mlannotations.MlannotationsFactory
 * @model kind="package"
 * @generated
 */
public interface MlannotationsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "mlannotations";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.mdelab.de/mlcore/mlannotations/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "mlcore.mlannotations";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	MlannotationsPackage eINSTANCE = de.mdelab.mlannotations.impl.MlannotationsPackageImpl
			.init();

	/**
	 * The meta object id for the '
	 * {@link de.mdelab.mlannotations.impl.MLAnnotationImpl
	 * <em>ML Annotation</em>}' class. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @see de.mdelab.mlannotations.impl.MLAnnotationImpl
	 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLAnnotation()
	 * @generated
	 */
	int ML_ANNOTATION = 0;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The feature id for the '<em><b>Source</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION__SOURCE = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The feature id for the '<em><b>Annotation Details</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION__ANNOTATION_DETAILS = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 1;

	/**
	 * The feature id for the '<em><b>Element</b></em>' container reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION__ELEMENT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 2;

	/**
	 * The number of structural features of the '<em>ML Annotation</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 3;

	/**
	 * The operation id for the '<em>UUID Not Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP;

	/**
	 * The number of operations of the '<em>ML Annotation</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlannotations.impl.MLAnnotationDetailsImpl <em>ML Annotation Details</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlannotations.impl.MLAnnotationDetailsImpl
	 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLAnnotationDetails()
	 * @generated
	 */
	int ML_ANNOTATION_DETAILS = 1;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_DETAILS__UUID = MlcorePackage.ML_ELEMENT_WITH_UUID__UUID;

	/**
	 * The number of structural features of the '<em>ML Annotation Details</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_DETAILS_FEATURE_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_FEATURE_COUNT
			+ 0;

	/**
	 * The operation id for the '<em>UUID Not Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_DETAILS___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = MlcorePackage.ML_ELEMENT_WITH_UUID___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP;

	/**
	 * The number of operations of the '<em>ML Annotation Details</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATION_DETAILS_OPERATION_COUNT = MlcorePackage.ML_ELEMENT_WITH_UUID_OPERATION_COUNT
			+ 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlannotations.impl.MLStringAnnotationDetailsImpl <em>ML String Annotation Details</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.mdelab.mlannotations.impl.MLStringAnnotationDetailsImpl
	 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLStringAnnotationDetails()
	 * @generated
	 */
	int ML_STRING_ANNOTATION_DETAILS = 2;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_STRING_ANNOTATION_DETAILS__UUID = ML_ANNOTATION_DETAILS__UUID;

	/**
	 * The feature id for the '<em><b>String Annotation</b></em>' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_STRING_ANNOTATION_DETAILS__STRING_ANNOTATION = ML_ANNOTATION_DETAILS_FEATURE_COUNT
			+ 0;

	/**
	 * The number of structural features of the '<em>ML String Annotation Details</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_STRING_ANNOTATION_DETAILS_FEATURE_COUNT = ML_ANNOTATION_DETAILS_FEATURE_COUNT
			+ 1;

	/**
	 * The operation id for the '<em>UUID Not Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_STRING_ANNOTATION_DETAILS___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = ML_ANNOTATION_DETAILS___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP;

	/**
	 * The number of operations of the '<em>ML String Annotation Details</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_STRING_ANNOTATION_DETAILS_OPERATION_COUNT = ML_ANNOTATION_DETAILS_OPERATION_COUNT
			+ 0;

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlannotations.MLAnnotation <em>ML Annotation</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>ML Annotation</em>'.
	 * @see de.mdelab.mlannotations.MLAnnotation
	 * @generated
	 */
	EClass getMLAnnotation();

	/**
	 * Returns the meta object for the attribute '{@link de.mdelab.mlannotations.MLAnnotation#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source</em>'.
	 * @see de.mdelab.mlannotations.MLAnnotation#getSource()
	 * @see #getMLAnnotation()
	 * @generated
	 */
	EAttribute getMLAnnotation_Source();

	/**
	 * Returns the meta object for the reference list '
	 * {@link de.mdelab.mlannotations.MLAnnotation#getAnnotationDetails
	 * <em>Annotation Details</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the reference list '
	 *         <em>Annotation Details</em>'.
	 * @see de.mdelab.mlannotations.MLAnnotation#getAnnotationDetails()
	 * @see #getMLAnnotation()
	 * @generated
	 */
	EReference getMLAnnotation_AnnotationDetails();

	/**
	 * Returns the meta object for the container reference '{@link de.mdelab.mlannotations.MLAnnotation#getElement <em>Element</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Element</em>'.
	 * @see de.mdelab.mlannotations.MLAnnotation#getElement()
	 * @see #getMLAnnotation()
	 * @generated
	 */
	EReference getMLAnnotation_Element();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlannotations.MLAnnotationDetails <em>ML Annotation Details</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>ML Annotation Details</em>'.
	 * @see de.mdelab.mlannotations.MLAnnotationDetails
	 * @generated
	 */
	EClass getMLAnnotationDetails();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlannotations.MLStringAnnotationDetails <em>ML String Annotation Details</em>}'.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @return the meta object for class '<em>ML String Annotation Details</em>'.
	 * @see de.mdelab.mlannotations.MLStringAnnotationDetails
	 * @generated
	 */
	EClass getMLStringAnnotationDetails();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlannotations.MLStringAnnotationDetails#getStringAnnotation
	 * <em>String Annotation</em>}'. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the meta object for the attribute '<em>String Annotation</em>'.
	 * @see de.mdelab.mlannotations.MLStringAnnotationDetails#getStringAnnotation()
	 * @see #getMLStringAnnotationDetails()
	 * @generated
	 */
	EAttribute getMLStringAnnotationDetails_StringAnnotation();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MlannotationsFactory getMlannotationsFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.mdelab.mlannotations.impl.MLAnnotationImpl <em>ML Annotation</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlannotations.impl.MLAnnotationImpl
		 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLAnnotation()
		 * @generated
		 */
		EClass ML_ANNOTATION = eINSTANCE.getMLAnnotation();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ML_ANNOTATION__SOURCE = eINSTANCE.getMLAnnotation_Source();

		/**
		 * The meta object literal for the '<em><b>Annotation Details</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ML_ANNOTATION__ANNOTATION_DETAILS = eINSTANCE
				.getMLAnnotation_AnnotationDetails();

		/**
		 * The meta object literal for the '<em><b>Element</b></em>' container reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ML_ANNOTATION__ELEMENT = eINSTANCE.getMLAnnotation_Element();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlannotations.impl.MLAnnotationDetailsImpl <em>ML Annotation Details</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlannotations.impl.MLAnnotationDetailsImpl
		 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLAnnotationDetails()
		 * @generated
		 */
		EClass ML_ANNOTATION_DETAILS = eINSTANCE.getMLAnnotationDetails();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlannotations.impl.MLStringAnnotationDetailsImpl <em>ML String Annotation Details</em>}' class.
		 * <!-- begin-user-doc
		 * --> <!-- end-user-doc -->
		 * @see de.mdelab.mlannotations.impl.MLStringAnnotationDetailsImpl
		 * @see de.mdelab.mlannotations.impl.MlannotationsPackageImpl#getMLStringAnnotationDetails()
		 * @generated
		 */
		EClass ML_STRING_ANNOTATION_DETAILS = eINSTANCE
				.getMLStringAnnotationDetails();

		/**
		 * The meta object literal for the '<em><b>String Annotation</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ML_STRING_ANNOTATION_DETAILS__STRING_ANNOTATION = eINSTANCE
				.getMLStringAnnotationDetails_StringAnnotation();

	}

} // MlannotationsPackage
