/**
 */
package de.mdelab.mlcore;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc --> The <b>Package</b> for the model. It contains
 * accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.mdelab.mlcore.MlcoreFactory
 * @model kind="package"
 * @generated
 */
public interface MlcorePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "mlcore";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.mdelab.de/mlcore/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "mlcore";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	MlcorePackage eINSTANCE = de.mdelab.mlcore.impl.MlcorePackageImpl.init();

	/**
	 * The meta object id for the '{@link de.mdelab.mlcore.impl.MLNamedElementImpl <em>ML Named Element</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlcore.impl.MLNamedElementImpl
	 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLNamedElement()
	 * @generated
	 */
	int ML_NAMED_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_NAMED_ELEMENT__NAME = 0;

	/**
	 * The number of structural features of the '<em>ML Named Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_NAMED_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>ML Named Element</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_NAMED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlcore.impl.MLElementWithUUIDImpl <em>ML Element With UUID</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlcore.impl.MLElementWithUUIDImpl
	 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLElementWithUUID()
	 * @generated
	 */
	int ML_ELEMENT_WITH_UUID = 1;

	/**
	 * The feature id for the '<em><b>Uuid</b></em>' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_ELEMENT_WITH_UUID__UUID = 0;

	/**
	 * The number of structural features of the '<em>ML Element With UUID</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ELEMENT_WITH_UUID_FEATURE_COUNT = 1;

	/**
	 * The operation id for the '<em>UUID Not Empty</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ELEMENT_WITH_UUID___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = 0;

	/**
	 * The number of operations of the '<em>ML Element With UUID</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ELEMENT_WITH_UUID_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.mdelab.mlcore.impl.MLAnnotatedElementImpl <em>ML Annotated Element</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlcore.impl.MLAnnotatedElementImpl
	 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLAnnotatedElement()
	 * @generated
	 */
	int ML_ANNOTATED_ELEMENT = 2;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATED_ELEMENT__ANNOTATIONS = 0;

	/**
	 * The number of structural features of the '<em>ML Annotated Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATED_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>ML Annotated Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_ANNOTATED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.mdelab.mlcore.impl.MLTypedElementImpl <em>ML Typed Element</em>}' class.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see de.mdelab.mlcore.impl.MLTypedElementImpl
	 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLTypedElement()
	 * @generated
	 */
	int ML_TYPED_ELEMENT = 3;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_TYPED_ELEMENT__TYPE = 0;

	/**
	 * The number of structural features of the '<em>ML Typed Element</em>' class.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ML_TYPED_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>ML Typed Element</em>' class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ML_TYPED_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlcore.MLNamedElement <em>ML Named Element</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>ML Named Element</em>'.
	 * @see de.mdelab.mlcore.MLNamedElement
	 * @generated
	 */
	EClass getMLNamedElement();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlcore.MLNamedElement#getName <em>Name</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.mdelab.mlcore.MLNamedElement#getName()
	 * @see #getMLNamedElement()
	 * @generated
	 */
	EAttribute getMLNamedElement_Name();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlcore.MLElementWithUUID <em>ML Element With UUID</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>ML Element With UUID</em>'.
	 * @see de.mdelab.mlcore.MLElementWithUUID
	 * @generated
	 */
	EClass getMLElementWithUUID();

	/**
	 * Returns the meta object for the attribute '
	 * {@link de.mdelab.mlcore.MLElementWithUUID#getUuid <em>Uuid</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Uuid</em>'.
	 * @see de.mdelab.mlcore.MLElementWithUUID#getUuid()
	 * @see #getMLElementWithUUID()
	 * @generated
	 */
	EAttribute getMLElementWithUUID_Uuid();

	/**
	 * Returns the meta object for the '{@link de.mdelab.mlcore.MLElementWithUUID#UUIDNotEmpty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map) <em>UUID Not Empty</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>UUID Not Empty</em>' operation.
	 * @see de.mdelab.mlcore.MLElementWithUUID#UUIDNotEmpty(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getMLElementWithUUID__UUIDNotEmpty__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link de.mdelab.mlcore.MLAnnotatedElement <em>ML Annotated Element</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for class '<em>ML Annotated Element</em>'.
	 * @see de.mdelab.mlcore.MLAnnotatedElement
	 * @generated
	 */
	EClass getMLAnnotatedElement();

	/**
	 * Returns the meta object for the containment reference list '{@link de.mdelab.mlcore.MLAnnotatedElement#getAnnotations <em>Annotations</em>}'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Annotations</em>'.
	 * @see de.mdelab.mlcore.MLAnnotatedElement#getAnnotations()
	 * @see #getMLAnnotatedElement()
	 * @generated
	 */
	EReference getMLAnnotatedElement_Annotations();

	/**
	 * Returns the meta object for class '
	 * {@link de.mdelab.mlcore.MLTypedElement <em>ML Typed Element</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>ML Typed Element</em>'.
	 * @see de.mdelab.mlcore.MLTypedElement
	 * @generated
	 */
	EClass getMLTypedElement();

	/**
	 * Returns the meta object for the reference '
	 * {@link de.mdelab.mlcore.MLTypedElement#getType <em>Type</em>}'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see de.mdelab.mlcore.MLTypedElement#getType()
	 * @see #getMLTypedElement()
	 * @generated
	 */
	EReference getMLTypedElement_Type();

	/**
	 * Returns the factory that creates the instances of the model. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MlcoreFactory getMlcoreFactory();

	/**
	 * <!-- begin-user-doc --> Defines literals for the meta objects that
	 * represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.mdelab.mlcore.impl.MLNamedElementImpl <em>ML Named Element</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlcore.impl.MLNamedElementImpl
		 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLNamedElement()
		 * @generated
		 */
		EClass ML_NAMED_ELEMENT = eINSTANCE.getMLNamedElement();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ML_NAMED_ELEMENT__NAME = eINSTANCE.getMLNamedElement_Name();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlcore.impl.MLElementWithUUIDImpl <em>ML Element With UUID</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlcore.impl.MLElementWithUUIDImpl
		 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLElementWithUUID()
		 * @generated
		 */
		EClass ML_ELEMENT_WITH_UUID = eINSTANCE.getMLElementWithUUID();

		/**
		 * The meta object literal for the '<em><b>Uuid</b></em>' attribute feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ML_ELEMENT_WITH_UUID__UUID = eINSTANCE
				.getMLElementWithUUID_Uuid();

		/**
		 * The meta object literal for the '<em><b>UUID Not Empty</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ML_ELEMENT_WITH_UUID___UUID_NOT_EMPTY__DIAGNOSTICCHAIN_MAP = eINSTANCE
				.getMLElementWithUUID__UUIDNotEmpty__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlcore.impl.MLAnnotatedElementImpl <em>ML Annotated Element</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlcore.impl.MLAnnotatedElementImpl
		 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLAnnotatedElement()
		 * @generated
		 */
		EClass ML_ANNOTATED_ELEMENT = eINSTANCE.getMLAnnotatedElement();

		/**
		 * The meta object literal for the '<em><b>Annotations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @generated
		 */
		EReference ML_ANNOTATED_ELEMENT__ANNOTATIONS = eINSTANCE
				.getMLAnnotatedElement_Annotations();

		/**
		 * The meta object literal for the '{@link de.mdelab.mlcore.impl.MLTypedElementImpl <em>ML Typed Element</em>}' class.
		 * <!-- begin-user-doc --> <!--
		 * end-user-doc -->
		 * @see de.mdelab.mlcore.impl.MLTypedElementImpl
		 * @see de.mdelab.mlcore.impl.MlcorePackageImpl#getMLTypedElement()
		 * @generated
		 */
		EClass ML_TYPED_ELEMENT = eINSTANCE.getMLTypedElement();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * @generated
		 */
		EReference ML_TYPED_ELEMENT__TYPE = eINSTANCE.getMLTypedElement_Type();

	}

} // MlcorePackage
