package de.mdelab.mlcore.ui.popup.actions;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import de.mdelab.mlcore.MLElementWithUUID;

public class ReassignUUIDsAction implements IObjectActionDelegate
{

	private List<MLElementWithUUID>	elements;

	/**
	 * Constructor for Action1.
	 */
	public ReassignUUIDsAction()
	{
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	@Override
	public void setActivePart(final IAction action, final IWorkbenchPart targetPart)
	{
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	@Override
	public void run(final IAction action)
	{
		for (final MLElementWithUUID element : this.elements)
		{
			element.setUuid(EcoreUtil.generateUUID());

			final TreeIterator<EObject> it = element.eAllContents();

			while (it.hasNext())
			{
				final EObject eObject = it.next();

				if (eObject instanceof MLElementWithUUID)
				{
					((MLElementWithUUID) eObject).setUuid(EcoreUtil.generateUUID());
				}
			}
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void selectionChanged(final IAction action, final ISelection selection)
	{
		if (selection instanceof IStructuredSelection)
		{
			this.elements = new ArrayList<MLElementWithUUID>(((IStructuredSelection) selection).toList());
		}
	}
}
