/**
 */
package de.mdelab.mlcore.util;

import de.mdelab.mlcore.*;

import java.util.Map;

import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see de.mdelab.mlcore.MlcorePackage
 * @generated
 */
public class MlcoreValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final MlcoreValidator INSTANCE = new MlcoreValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "de.mdelab.mlcore";

	/**
	 * The {@link org.eclipse.emf.common.util.Diagnostic#getCode() code} for constraint 'UUID Not Empty' of 'ML Element With UUID'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final int ML_ELEMENT_WITH_UUID__UUID_NOT_EMPTY = 1;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 1;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MlcoreValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
		return MlcorePackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case MlcorePackage.ML_NAMED_ELEMENT :
				return validateMLNamedElement((MLNamedElement) value,
						diagnostics, context);
			case MlcorePackage.ML_ELEMENT_WITH_UUID :
				return validateMLElementWithUUID((MLElementWithUUID) value,
						diagnostics, context);
			case MlcorePackage.ML_ANNOTATED_ELEMENT :
				return validateMLAnnotatedElement((MLAnnotatedElement) value,
						diagnostics, context);
			case MlcorePackage.ML_TYPED_ELEMENT :
				return validateMLTypedElement((MLTypedElement) value,
						diagnostics, context);
			default :
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMLNamedElement(MLNamedElement mlNamedElement,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(mlNamedElement, diagnostics,
				context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMLElementWithUUID(
			MLElementWithUUID mlElementWithUUID, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		if (!validate_NoCircularContainment(mlElementWithUUID, diagnostics,
				context))
			return false;
		boolean result = validate_EveryMultiplicityConforms(mlElementWithUUID,
				diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryDataValueConforms(mlElementWithUUID,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryReferenceIsContained(mlElementWithUUID,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryBidirectionalReferenceIsPaired(
					mlElementWithUUID, diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_EveryProxyResolves(mlElementWithUUID,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validate_UniqueID(mlElementWithUUID, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryKeyUnique(mlElementWithUUID, diagnostics,
					context);
		if (result || diagnostics != null)
			result &= validate_EveryMapEntryUnique(mlElementWithUUID,
					diagnostics, context);
		if (result || diagnostics != null)
			result &= validateMLElementWithUUID_UUIDNotEmpty(mlElementWithUUID,
					diagnostics, context);
		return result;
	}

	/**
	 * Validates the UUIDNotEmpty constraint of '<em>ML Element With UUID</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMLElementWithUUID_UUIDNotEmpty(
			MLElementWithUUID mlElementWithUUID, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return mlElementWithUUID.UUIDNotEmpty(diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMLAnnotatedElement(
			MLAnnotatedElement mlAnnotatedElement, DiagnosticChain diagnostics,
			Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(mlAnnotatedElement, diagnostics,
				context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateMLTypedElement(MLTypedElement mlTypedElement,
			DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(mlTypedElement, diagnostics,
				context);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //MlcoreValidator
